-- Business
UPDATE business SET projectNumberingEnabled=FALSE WHERE projectNumberingEnabled IS NULL;
UPDATE business SET taxesEnabled=FALSE WHERE taxesEnabled IS NULL;
UPDATE business SET minimumInterval=0 WHERE minimumInterval IS NULL;

ALTER TABLE business ALTER COLUMN billableTimeExactPrecisionEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN billingEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN enabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN expensesEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN invoiceNumberingEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN invoiceNumberingPerClientEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN productsEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN projectNumberingEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN taxesEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN tripsEnabled SET NOT NULL;
ALTER TABLE business ALTER COLUMN roundingInterval SET NOT NULL;
ALTER TABLE business ALTER COLUMN minimumInterval SET NOT NULL;

-- CatalogItem
ALTER TABLE catalogitem ALTER COLUMN enabled SET NOT NULL;

-- Client
UPDATE client SET active=TRUE WHERE active IS NULL;
UPDATE client SET taxExempt=FALSE WHERE taxExempt IS NULL;
UPDATE client SET taskBillable=TRUE WHERE taskBillable IS NULL;
UPDATE client SET taskTimeMinimumInterval=0 WHERE taskTimeMinimumInterval IS NULL;

ALTER TABLE client ALTER COLUMN active SET NOT NULL;
ALTER TABLE client ALTER COLUMN billable SET NOT NULL;
ALTER TABLE client ALTER COLUMN taxExempt SET NOT NULL;
ALTER TABLE client ALTER COLUMN taskBillable SET NOT NULL;
ALTER TABLE client ALTER COLUMN taskTimeRoundingEnabled SET NOT NULL;
ALTER TABLE client ALTER COLUMN taskTimeRoundingInterval SET NOT NULL;
ALTER TABLE client ALTER COLUMN taskTimeMinimumInterval SET NOT NULL;

-- Deposit
ALTER TABLE deposit ALTER COLUMN date SET NOT NULL;

-- Expense
ALTER TABLE expense ALTER COLUMN billable SET NOT NULL;
ALTER TABLE expense ALTER COLUMN taxGroupEnabled SET NOT NULL;
ALTER TABLE expense ALTER COLUMN date SET NOT NULL;

-- ExpenseCategory
ALTER TABLE expensecategory ALTER COLUMN enabled SET NOT NULL;

-- Invoice
UPDATE invoice SET cancelled=FALSE WHERE cancelled IS NULL;
UPDATE invoice SET paid=FALSE WHERE paid IS NULL;

ALTER TABLE invoice ALTER COLUMN cancelled SET NOT NULL;
ALTER TABLE invoice ALTER COLUMN paid SET NOT NULL;
ALTER TABLE invoice ALTER COLUMN totalDiscountEnabled SET NOT NULL;
ALTER TABLE invoice ALTER COLUMN date SET NOT NULL;

-- Item
UPDATE item SET minimumInterval=0 WHERE minimumInterval IS NULL;
UPDATE item SET billableTimeExactPrecisionEnabled=FALSE WHERE billableTimeExactPrecisionEnabled IS NULL;

ALTER TABLE item ALTER COLUMN taxGroupEnabled SET NOT NULL;
ALTER TABLE item ALTER COLUMN enabled SET NOT NULL;
ALTER TABLE item ALTER COLUMN unitsDiscountEnabled SET NOT NULL;
ALTER TABLE item ALTER COLUMN rateDiscountEnabled SET NOT NULL;
ALTER TABLE item ALTER COLUMN billableTimeExactPrecisionEnabled SET NOT NULL;
ALTER TABLE item ALTER COLUMN roundingInterval SET NOT NULL;
ALTER TABLE item ALTER COLUMN minimumInterval SET NOT NULL;

-- Payment
ALTER TABLE payment ALTER COLUMN date SET NOT NULL;

-- Product
ALTER TABLE product ALTER COLUMN taxGroupEnabled SET NOT NULL;
ALTER TABLE product ALTER COLUMN quantityDiscountEnabled SET NOT NULL;
ALTER TABLE product ALTER COLUMN priceDiscountEnabled SET NOT NULL;
ALTER TABLE product ALTER COLUMN date SET NOT NULL;

-- Project
UPDATE project SET taskBillable=TRUE WHERE taskBillable IS NULL;
UPDATE project SET expenseBillable=TRUE WHERE taskBillable IS NULL;
UPDATE project SET tripBillable=TRUE WHERE taskBillable IS NULL;
UPDATE project SET taskTimeMinimumInterval=0 WHERE taskTimeMinimumInterval IS NULL;

ALTER TABLE project ALTER COLUMN billable SET NOT NULL;
ALTER TABLE project ALTER COLUMN taskBillable SET NOT NULL;
ALTER TABLE project ALTER COLUMN expenseBillable SET NOT NULL;
ALTER TABLE project ALTER COLUMN tripBillable SET NOT NULL;
ALTER TABLE project ALTER COLUMN taskTimeRoundingEnabled SET NOT NULL;
ALTER TABLE project ALTER COLUMN startDate SET NOT NULL;
ALTER TABLE project ALTER COLUMN taskTimeRoundingInterval SET NOT NULL;
ALTER TABLE project ALTER COLUMN taskTimeMinimumInterval SET NOT NULL;

-- Task
UPDATE task SET completed=FALSE WHERE completed IS NULL;
UPDATE task SET billable=TRUE WHERE billable IS NULL;
UPDATE task SET timeRoundingMinimumInterval=0 WHERE timeRoundingMinimumInterval IS NULL;
UPDATE task SET estimatedTime=0 WHERE estimatedTime IS NULL;

ALTER TABLE task ALTER COLUMN completed SET NOT NULL;
ALTER TABLE task ALTER COLUMN billable SET NOT NULL;
ALTER TABLE task ALTER COLUMN taxGroupEnabled SET NOT NULL;
ALTER TABLE task ALTER COLUMN timeRoundingEnabled SET NOT NULL;
ALTER TABLE task ALTER COLUMN priceDiscountEnabled SET NOT NULL;
ALTER TABLE task ALTER COLUMN quantityDiscountEnabled SET NOT NULL;
ALTER TABLE task ALTER COLUMN startDate SET NOT NULL;
ALTER TABLE task ALTER COLUMN timeRoundingInterval SET NOT NULL;
ALTER TABLE task ALTER COLUMN timeRoundingMinimumInterval SET NOT NULL;
ALTER TABLE task ALTER COLUMN estimatedTime INTEGER;
ALTER TABLE task ALTER COLUMN estimatedTime SET NOT NULL;

-- TaskCategory
UPDATE taskcategory SET timeRoundingMinimumInterval=0 WHERE timeRoundingMinimumInterval IS NULL;

ALTER TABLE taskcategory ALTER COLUMN enabled SET NOT NULL;
ALTER TABLE taskcategory ALTER COLUMN billable SET NOT NULL;
ALTER TABLE taskcategory ALTER COLUMN timeRoundingEnabled SET NOT NULL;
ALTER TABLE taskcategory ALTER COLUMN timeRoundingInterval SET NOT NULL;
ALTER TABLE taskcategory ALTER COLUMN timeRoundingMinimumInterval SET NOT NULL;

-- TaxGroup
UPDATE taxgroup SET enabled=TRUE WHERE enabled IS NULL;

ALTER TABLE taxgroup ALTER COLUMN enabled SET NOT NULL;

-- TaxRule
ALTER TABLE taxrule ALTER COLUMN additive SET NOT NULL;

-- TimeEntry
UPDATE timeentry SET pausedTime=0 WHERE pausedTime IS NULL;

-- Reset the pause for time entries if it's larger than max int (2^31-1) and add a #longpause tag to them
UPDATE timeentry SET tags=concat(tags, concat(',#longpause-', pausedTime)) WHERE pausedTime>2147483647;
UPDATE timeentry SET pausedTime=0 WHERE pausedTime>2147483647;

ALTER TABLE timeentry ALTER COLUMN billable SET NOT NULL;
ALTER TABLE timeentry ALTER COLUMN date SET NOT NULL;
ALTER TABLE timeentry ALTER COLUMN elapsedTime INTEGER;
ALTER TABLE timeentry ALTER COLUMN elapsedTime SET NOT NULL;
ALTER TABLE timeentry ALTER COLUMN pausedTime INTEGER;
ALTER TABLE timeentry ALTER COLUMN pausedTime SET NOT NULL;
ALTER TABLE timeentry ALTER COLUMN explicitBillableTime INTEGER;

-- Trip
ALTER TABLE trip ALTER COLUMN billable SET NOT NULL;

-- TripRate
ALTER TABLE triprate ALTER COLUMN enabled SET NOT NULL;