-- Round time down to 1 minute (all) for all service items billed in hours that contain time entries with
-- default billable time (explicit is null) and with fractions of a minute (time % 60 != 0).

-- item.roundingmode = -1 -> down
-- item.roundingcalculation = 0 -> all
-- item.roundinginterval = 60 -> 1 minute
-- item.quantitytype = 1 -> hours
-- item.enabled -> rounding is enabled or not

UPDATE item
   SET roundingmode = -1,
       roundingcalculation = 0,
       roundinginterval = 60,
       minimuminterval = 0,
       enabled = TRUE
 WHERE itemid IN
       (SELECT item.itemid
          FROM item
               LEFT OUTER JOIN timeentry
               ON item.itemid = timeentry.itemid
         WHERE item.quantitytype = 1
           AND item.enabled = FALSE
           AND timeentry.explicitbillabletime IS NULL
           AND MOD(timeentry.elapsedtime, 60) <> 0
         GROUP BY item.itemid);